#property indicator_chart_window //  
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_maximum 100
#property indicator_minimum 0

//   MasterSlave
extern int Source=1; // 0 - ; 1 - . ; 2 - ATR; 3 - ; 
extern int SourcePeriod=88; //   
extern int Window=300; //   
extern double Sensitivity=0; // 
extern int Signal=55; //    ()

extern double KperiodFrom = 0.09; //  
extern double KperiodTo = 0.001; // 

//  
double Sar[]; // 

bool first=1; //    

int init() {
   SetIndexBuffer(0,Sar); 
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexLabel(0,"Sar");
   return(0);
  }

int start() {
   int ic=IndicatorCounted();
   if(!first && Bars-ic>2) ic=reinit(); //        ( )
   
   int limit=Bars-ic-1;
   for(int i=limit; i>=0; i--) {
      //  
      double k=iCustom(NULL,0,"_MasterSlave",Source,SourcePeriod,Window,Sensitivity,Signal, 0,i); 
//      Master[i]=100*k;
      //   
      double Kperiod=KperiodFrom+k*(KperiodTo-KperiodFrom); 
//      K[i]=Kperiod; // %K 
//      int Slowing=SlowingFrom+k*(SlowingTo-SlowingFrom); Slow[i]=Slowing; // Slowing 
//      OS[i]=OverSoldFrom+k*(OverSoldTo-OverSoldFrom); OB[i]=100-OS[i]; //  /
      // 
//      Stoch[i]=iStochastic(NULL,0,Kperiod,1,Slowing,0,0, 0,i);
      Sar[i] = iSAR(NULL, 0,Kperiod, 0.2, i);
     }
   first=0; //    
   return(0);
  }
//+------------------------------------------------------------------+
  
int reinit() { //  
   ArrayInitialize(Sar,0.0); 
   
   return(0);
  }